︠8d909248-827e-4e23-8913-cf0c16afec85i︠
%md
# RSA
## La mécanique et quelques exemples

On choisit $n = pq$, un nombre assez grand.

- Clé publique : $(a,n)$ où $a$ et $ m = (p-1)(q-1)$ sont relativement premiers, ce qui garantit que $a$ est inversible modulo $m$,
- Clé privé : $(c,n)$ où $c$ est l'inverse de $a$ modulo $m$.
- Fonction d'encryption : $y = x^a \mod n$
- Déchiffrement $x= y^c \mod  n$


︡49cb7163-8698-49c2-9c45-9ae60b2c4daf︡{"md":"# RSA\n## La mécanique et quelques exemples\n\nOn choisit $n = pq$, un nombre assez grand.\n\n- Clé publique : $(a,n)$ où $a$ et $ m = (p-1)(q-1)$ sont relativement premiers, ce qui garantit que $a$ est inversible modulo $m$,\n- Clé privé : $(c,n)$ où $c$ est l'inverse de $a$ modulo $m$.\n- Fonction d'encryption : $y = x^a \\mod n$\n- Déchiffrement $x= y^c \\mod  n$\n\n\n"}︡
︠3fffd1f4-27f0-4a39-b324-e85ebda05662i︠
%md
## Exemple

On se donne deux nombres premiers, $p=43, q=59$, puis on calcule $n=pq$
n
︡e2d2aeee-7a2e-4c39-8215-fcb1ecbbd35a︡{"md":"## Exemple\n\nOn se donne deux nombres premiers, $p=43, q=59$, puis on calcule $n=pq$ \nn\n"}︡
︠ddcbdfac-d972-41ab-b537-638acc84c46b︠
typeset_mode(True)
︡95ce30fd-8386-4bd5-b27d-bb8443a92b9a︡
︠0e8d8883-261d-4b10-b70c-1fdbb804636c︠
p=43
q=59
n=p*q
n
︡869223e8-56ee-470d-ad3b-325fc64d1e53︡{"tex":{"tex":"2537","display":true}}︡
︠d039c2c6-250e-4099-abca-b383d178a649i︠
%md
Pour l'encryption, on a besoin de $m=(p-1)(q-1)$ et d'un nombre $a$, inversible modulo $n$. La chose la plus simple à faire (mais probablement pas si sécuritaire que ça, c'est de prendre $a=$ un nombre premier). On doit calculer l'inverse de $a$ mod $m$, chose qu'à la main serait faite avec l'algorithme d'Euclide et la relation de Bézout, mais on peut faire ici directement.
︡e1ce49f4-49a1-4926-8605-da19bbad4805︡{"md":"Pour l'encryption, on a besoin de $m=(p-1)(q-1)$ et d'un nombre $a$, inversible modulo $n$. La chose la plus simple à faire (mais probablement pas si sécuritaire que ça, c'est de prendre $a=$ un nombre premier). On doit calculer l'inverse de $a$ mod $m$, chose qu'à la main serait faite avec l'algorithme d'Euclide et la relation de Bézout, mais on peut faire ici directement.\n"}︡
︠8d04e438-bde0-442f-bf11-bce730fb311c︠
m=(p-1)*(q-1)
print "m = " , m
a=13
c=a.inverse_mod(m)
print "c = " , c

︡bf2b69fa-8d0f-463e-a90b-b155f7bf5b06︡{"stdout":"m =  2436\n"}︡{"stdout":"c =  937\n"}︡
︠510f6c4d-d65d-4cd5-9a74-622279668623︠
13.inverse_mod(2537)
︡12005faf-18d0-4ba2-a798-be7cbb6fd824︡{"stdout":"1171\n"}︡
︠169600a0-5f4d-49c1-90ce-f6bb4a64dd51︠
13.inverse_mod(2537)
︡12005faf-18d0-4ba2-a798-be7cbb6fd824︡{"stdout":"1171\n"}︡
︠135fd0e8-bcdf-4fba-94e8-ac3d312d15b3︠
︠a065f52e-280a-49f6-88d9-6ae7a3d467e4i︠
%md
### Supposons que l'on veuille transmettre le message $x=1819$
︡f194c38d-ecaa-4015-b65d-cac9434a9f4a︡{"md":"### Supposons que l'on veuille transmettre le message $x=1819$\n"}︡
︠958b622a-6012-47d7-9af9-bcf991d5ada6︠
x=1819
x^a
(x^a)%n
y=power_mod(x, a, n)
y
︡5e3cf9b5-cf7b-44dc-ade6-b75acdb99d27︡{"tex":{"tex":"2386849785157107040709612162538837068104459","display":true}}︡{"tex":{"tex":"2081","display":true}}︡{"tex":{"tex":"2081","display":true}}︡
︠3acaf0db-50e4-426c-bb0a-3dedcb25717a︠
︠68fdd33f-9333-48c3-8049-3d7d735e9fe6︠
(y^c)%n
︡a689bf13-0ed7-4363-ad04-6343e798fa04︡{"tex":{"tex":"1819","display":true}}︡
︠c0a7924c-e512-41de-8e7c-aa64ce6f3f47︠
power_mod(y,c,n)
︡d2d3d24d-2c4f-4f9f-abc2-6acc9ca701ef︡{"tex":{"tex":"1819","display":true}}︡
︠17de7da2-489c-48b8-adb3-22eece0160fei︠
%md
## Remarque :
Faire l'exponentiation, puis la réduction modulaire dans notre cas est, à toutes fins pratiques, équivalent (l'ordi va assez vite pour que la différence soit imperceptibe). Voyons avec des nombres un peu plus grands
︡d0c3243b-9d7d-4ddc-b66e-7ea3ef3acb4e︡{"md":"## Remarque :\nFaire l'exponentiation, puis la réduction modulaire dans notre cas est, à toutes fins pratiques, équivalent (l'ordi va assez vite pour que la différence soit imperceptibe). Voyons avec des nombres un peu plus grands\n"}︡
︠291eb9d1-e381-406e-8320-1e7a9e6cb886︠
p_1=next_prime(10^10)
p_1
p_2 =random_prime(10^10)
p_2
n_1=p_1 * p_2
n_1
︡c5e16d30-07e3-47f3-a285-ba83bfb93bdf︡{"stdout":"10000000019\n"}︡{"stdout":"1201237607\n"}︡{"stdout":"12012376092823514533\n"}︡
︠4b4d61d5-3708-46bc-a33d-fb0ef1f099a0︠
a=random_prime(10^10)
a
︡59afd4a7-03d6-4e87-b942-1da54a0330ec︡{"stdout":"667905419\n"}︡
︠c0e48972-df60-42eb-b20e-3da665daffac︠
x=12345678910111213141516171819
x
︡4d174ec5-92c3-4c4c-a033-dcd61244b114︡{"stdout":"12345678910111213141516171819\n"}︡
︠4f13cbc5-9ca1-411e-87dc-01fd9e284575︠
%time power_mod(x,a,n_1)
︡61b681f8-8980-4e16-ab85-dab8e2cc728f︡{"stdout":"11948623708869854250\n"}︡{"stdout":"CPU time: 0.00 s, Wall time: 0.00 s\n"}︡
︠851b64fa-d7a6-45f4-9cf5-5cd1f779ad74︠
%time x^a
︡3386e9ac-a500-4940-919c-ab5bbab586a1︡
︠51c04b93-8892-40f8-a8ec-68397718f2c3︠

︠f63acbd4-dbc5-4796-98a9-c92d670eee1di︠
%md
Une petite fonction utile pour l'algorithme d'Euclide.
︡273bd813-8ffd-4f7d-a51a-fdbf010fa732︡{"md":"Une petite fonction utile pour l'algorithme d'Euclide.\n"}︡
︠d5460399-5404-4815-887f-2bef22d9b28a︠
def Div(a,b):
	return [floor(a/b), a%b]
︡4298f8e0-8da6-4ca3-a912-2de0d1689aae︡
︠92a5c69d-1e88-4316-a874-72be53bb9322︠
Div(2537,13)
︡0e052f21-069b-4e3c-8ae1-87b70f70985c︡{"stdout":"[195, 2]\n"}︡
︠5e7c24fa-aa80-4fbc-8110-7fd8ec15eb0ai︠
%md
# Une de pirates!
10 pirates trouvent un sac avec des pièces d'or (égales).

- Ils essayent de se partager les pièces de façon juste et équitable.
- Ceci est impossible, car il leur reste une piece d'or. Un pirate fâché, qutte.
- Les pirates restants essayent de se distribuer le buttin. Ceci est encore impossible, il leur reste deux pièces cette fois.
- UDeux autres pirates quittent, et les autres recommencent. Il se trouve que cette fois, tout marche.

Quel est le nombre minimal de pièces ?

︡52e439c8-b369-485d-b0c3-f6c898c177c0︡{"md":"# Une de pirates!\n10 pirates trouvent un sac avec des pièces d'or (égales).\n\n- Ils essayent de se partager les pièces de façon juste et équitable.\n- Ceci est impossible, car il leur reste une piece d'or. Un pirate fâché, qutte.\n- Les pirates restants essayent de se distribuer le buttin. Ceci est encore impossible, il leur reste deux pièces cette fois.\n- UDeux autres pirates quittent, et les autres recommencent. Il se trouve que cette fois, tout marche.\n\nQuel est le nombre minimal de pièces ?\n\n"}︡
︠80804c56-d72d-46c3-8dec-56dae574f8dd︠
crt(1,2,10,9)
︡e37c5f46-5c01-4d97-9d5d-80149c947eec︡{"stdout":"11\n"}︡
︠7131dab9-d94e-4f8c-b228-985aa9d5f488︠
crt(11,0,90,7)
︡4ed03436-ba46-47de-9a8a-c48e91edf8b1︡{"stdout":"371\n"}︡
︠6779cf01-7e2d-444c-a7ea-e2959f88c5c9︠
371%7
︡ac2b0921-ef86-4feb-8160-96ee67b4aad1︡{"stdout":"0\n"}︡
︠dc399cb0-06f1-43ad-9832-d7b93d7a00cc︠









